Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, LazJPG, math, process, UTF8Process;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Image1: TImage;
    Label1: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Panel1: TPanel;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Procedure Button1Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure Image1Paint(Sender: TObject);
    Procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure ProceedFind(Filename: String);
    Procedure GetFilesInDirectory(ADirectory: String; Const AMask: Tstringlist; ARekursiv: Boolean);

  private
    { private declarations }
  public
    { public declarations }
    Procedure LoadExifData(Filename: String);
  End;

Var
  Form1: TForm1;
  b2, b: TBitmap;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure Tform1.LoadExifData(Filename: String);
//Var
//  p: TProcessUTF8;
//  s: String;
//  AStringList: TStringList;
Begin
//
//  // Erscht mal alles Löscha
//  ListBox2.Clear;
//  p := TProcessUTF8.Create(Nil);
//  s := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
//  p.Executable := s + 'exiftool.exe';
//  p.Parameters.clear;
//  p.Parameters.Add('"-w txt"');
//  p.Parameters.Add(Filename);
//  p.Options := [poWaitOnExit];
//  p.Execute;
//  AStringList := TStringList.Create;
//  s := ExtractFileNameWithoutExt(filename) + '.txt';
//  AStringList.LoadFromFile(s);
//  showmessage(AStringList.Text);
//  AStringList.Free;
//  DeleteFile(s);
//  p.free;
End;

Procedure Tform1.ProceedFind(Filename: String);
Begin
  // Hier steht der Code der mit den gefundenen Dateien aufgerufen werden soll
  ListBox1.Items.Add(ExtractFileName(systoutf8(Filename)));
End;

Procedure TForm1.GetFilesInDirectory(ADirectory: String; Const AMask: Tstringlist; ARekursiv: Boolean);
Var
  sr: TSearchRec;
  ext: String;
  i: integer;
Begin
  // Include Trailing Backslash
  ADirectory := IncludeTrailingPathDelimiter(ADirectory);
  // Suchen der Dateien im Ordner
  If (FindFirst(ADirectory + '*', faAnyFile And faDirectory, SR) = 0) Then Begin
    Repeat
      // Dank dieser Variante sind wir case insensitiv, obwohl es das Betriebsystem eventuell ist !
      ext := ExtractFileExt(ADirectory + SR.Name);
      For i := 0 To amask.count - 1 Do
        If lowercase(ext) = amask[i] Then
          ProceedFind(ADirectory + SR.Name);
      (*
      Rekursiver Abstieg
      *)
      If ARekursiv Then Begin
        If (SR.Name <> '.') And (SR.Name <> '..') And (SR.Attr And FaDirectory = FaDirectory) Then
          GetFilesInDirectory(ADirectory + SR.Name, AMask, True);
      End;
    Until FindNext(SR) <> 0;
  End;
  FindClose(SR);
End;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  Panel1.Caption := '';
  Label1.Caption := 'Keins';
  SelectDirectoryDialog1.InitialDir := ExtractFileDir(ParamStrUTF8(0));
  //Image1.Stretch := True;
  b := TBitmap.Create;
  b2 := TBitmap.Create;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Var
  mask: TStringList;
Begin
  If SelectDirectoryDialog1.Execute Then Begin
    label1.caption := systoutf8(SelectDirectoryDialog1.FileName);
    ListBox1.Items.Clear;
    ListBox1.Items.BeginUpdate;
    mask := TStringList.Create;
    mask.add('.jpg');
    // Todo : Einfügen Support für CR2 Format
    //mask.add('.cr2');
    GetFilesInDirectory(SelectDirectoryDialog1.FileName, mask, false);
    ListBox1.Items.EndUpdate;
    mask.free;
  End;
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Begin
  b.free;
  b2.free;
End;

Procedure TForm1.FormShow(Sender: TObject);
Begin
  GroupBox1.Align := alLeft;
  Splitter1.Align := alLeft;
  GroupBox2.Align := alRight;
  Splitter2.Align := alRight;
  Panel1.Align := alClient;
  GroupBox3.Align := alBottom;
  Splitter3.Align := alBottom;
  GroupBox4.Align := alClient;
  ListBox2.Align := alClient;
End;

Procedure TForm1.Image1Paint(Sender: TObject);
Var
  wz, hz, w, h: integer;
  scale: single;
Begin
  (* Das Flackern des Bildes kommt daher, dass man mit dem Cursor über einen der TSplitter fährt..*)
//Das liegt im Mouse Enter der Groupbox, aber keine Ahnung warum ..
  If Not assigned(b) Then exit;
  If Image1.Width <> GroupBox4.Width - 8 Then
    Image1.Width := GroupBox4.Width - 8;
  If Image1.Height <> GroupBox4.Height - 24 Then
    Image1.Height := GroupBox4.Height - 24;
  w := b.Width;
  h := b.Height;
  If (w = 0) Or (h = 0) Then exit;
  wz := Image1.Width;
  hz := Image1.Height;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Pen.Color := clBtnFace;
  Image1.Canvas.Rectangle(0, 0, wz, hz);
  If (wz >= w) And (hz >= h) Then Begin
    b2.Width := w;
    b2.Height := h;
    b2.Canvas.Draw(0, 0, b);
    Image1.Canvas.Draw(0, 0, b2);
  End
  Else Begin
    scale := 1;
    If (wz < w) Then
      scale := wz / w;
    If (hz < h) Then
      scale := min(scale, hz / h);
    b2.Width := round(w * scale);
    b2.Height := round(h * scale);
    //b2.Canvas.Brush.Color := clBtnFace;
    //b2.Canvas.Brush.Style := bsSolid;
    //b2.Canvas.Pen.Color := clBtnFace;
    //b2.Canvas.Rectangle(0, 0, wz, hz);
    b2.Canvas.StretchDraw(rect(0, 0, b2.width, b2.height), b);
    Image1.Canvas.Draw(0, 0, b2);
  End;

  //If Not assigned(b) Then exit;
  //If Image1.Width <> GroupBox4.Width - 8 Then
  //  Image1.Width := GroupBox4.Width - 8;
  //If Image1.Height <> GroupBox4.Height - 8 Then
  //  Image1.Height := GroupBox4.Height - 8;
  //w := b.Width;
  //h := b.Height;
  //if (w = 0 )or (h = 0 )then exit;
  //wz := Image1.Width;
  //hz := Image1.Height;
  //Image1.Canvas.Brush.Color := clBtnFace;
  //Image1.Canvas.Brush.Style := bsSolid;
  //Image1.Canvas.Pen.Color := clBtnFace;
  //Image1.Canvas.Rectangle(0, 0, wz, hz);
  //If (wz >= w) And (hz >= h) Then Begin
  //  b2.Width := w;
  //  b2.Height := h;
  //  b2.Canvas.Draw(0, 0, b);
  //  Image1.Canvas.Draw(0, 0, b2);
  //End
  //Else Begin
  //  scale := 1;
  //  If (wz < w) Then
  //    scale := wz / w;
  //  If (hz < h) Then
  //    scale := min(scale, hz / h);
  //  b2.Width := round(w * scale);
  //  b2.Height := round(h * scale);
  //  b2.Canvas.StretchDraw(rect(0, 0, b2.width, b2.height), b);
  //  Image1.Canvas.Draw(0, 0, b2);
  //End;
End;

Procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
  jp: TJPGImage;
Begin
  If ListBox1.ItemIndex <> -1 Then Begin
    //Image1.Picture.LoadFromFile({utf8tosys}(Label1.Caption + PathDelim + ListBox1.Items[ListBox1.ItemIndex]));
    jp := TJPGImage.Create;
    jp.LoadFromFile({utf8tosys}(Label1.Caption + PathDelim + ListBox1.Items[ListBox1.ItemIndex]));
    b.Assign(jp);
    Image1Paint(Nil);
    //Image1.Invalidate;
    LoadExifData(utf8tosys(Label1.Caption + PathDelim + ListBox1.Items[ListBox1.ItemIndex]));
    jp.Free;
  End;
End;

End.

